#include <cstdlib>
#include <iostream>
#include <iomanip>

#include "matrix.h"

std::ostream& operator<<(std::ostream & out, const Matrix & m);

int main(int argc, char *argv[])
{
   std::cout << "I like CPL!" << std::endl;

   Matrix a(3,4);
   Matrix *b = new Matrix(2,2);

   try {
   std::cout 
      << "size of matrix a " 
      << a.getRows() << "x" << a.getCols() 
      << std::endl
      ;

//   a.print(std::cout);
   std::cout << a << " matrix b is: " << std::endl << b;

   } catch (std::out_of_range & e) {
      std::cerr << "ERROR: out of range '" << e.what() << "'" << std::endl;
   }
   delete b;
   return EXIT_SUCCESS;
}

std::ostream& operator<<(std::ostream & out, const Matrix & m)
{ 
   for (int r = 0; r < m.getRows(); ++r) {
      for (int c = 0; c < m.getCols(); ++c) {
         out 
            << std::fixed << std::setw(6) << std::setprecision(2) 
            << m.getValueAt(r, c) << " ";
      }
      out << std::endl;
   }
   return out;
}
